from Components.MenuList import MenuList
from Components.Label import Label

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap
from Components.Input import Input
from Components.Pixmap import Pixmap
from Components.FileList import FileList
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap
from Screens.InputBox import InputBox, PinInput

from twisted.web.client import getPage, downloadPage

from enigma import eServiceReference
from enigma import eServiceCenter

######################################################################
#                                                                    #
#   MetacafeDirect    : Coded by pcd@i-have-a-dreambox, August 2010  #
#   This is free software; you can redistribute it and/or modify it. #
#   However, you are politely requested to retain these 3 lines.     #
#                                                                    #
######################################################################


class Vidtype(Screen):
    skin = """
		<screen position="200,200" size="350,300" title="Categories" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="345,280" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""
    def __init__(self, session):
		self.skin = Vidtype.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

                self.ict = 0
                self.onLayoutFinish.append(self.startSession)

    def startSession(self):
                vidtype = []
                self.urltype = []
              
                vidtype.append("Search")

                vidtype.append("filmtrailers 1")
                vidtype.append("filmtrailers 2")
                vidtype.append("filmtrailers 3")
                
                vidtype.append("sports football")
                vidtype.append("sports extreme")
                vidtype.append("sports tennis")
                vidtype.append("sports golf")
                
                vidtype.append("news_items")
                vidtype.append("news_items_2")
                vidtype.append("people_and_stories")
                vidtype.append("science_and_tech")
                vidtype.append("travel_and_outdoors")                
                vidtype.append("most popular videos")
                
                vidtype.append("video games")
                vidtype.append("music_and_dance")
                vidtype.append("watchmojo")
                vidtype.append("weather")

                self.urltype.append("")
                self.urltype.append("http://www.metacafe.com/filmtrailer/")
                self.urltype.append("http://www.metacafe.com/filmtrailer/english/page-2/")
                self.urltype.append("http://www.metacafe.com/filmtrailer/english/page-3/")

                self.urltype.append("http://www.metacafe.com/sports_clips/football/")
                self.urltype.append("http://www.metacafe.com/sports_clips/extreme/")
                self.urltype.append("http://www.metacafe.com/sports_clips/tennis/")
                self.urltype.append("http://www.metacafe.com/sports_clips/golf/")
                
                self.urltype.append("http://www.metacafe.com/itn/")
                self.urltype.append("http://www.metacafe.com/itn/page-2/")
                self.urltype.append("http://www.metacafe.com/videos/people_and_stories/newest/")
                self.urltype.append("http://www.metacafe.com/videos/science_and_tech/newest/")
                self.urltype.append("http://www.metacafe.com/videos/travel_and_outdoors/newest/")                
                self.urltype.append("http://www.metacafe.com/videos/most_popular/")

                self.urltype.append("http://www.metacafe.com/video-games/")
                self.urltype.append("http://www.metacafe.com/f/videos/music_and_dance/most_popular/")
                self.urltype.append("http://www.metacafe.com/watchmojo/")
                self.urltype.append("http://www.metacafe.com/weather/")
                
                self["list"].setList(vidtype)
    
    def okClicked(self):
	itype = self["list"].getSelectionIndex()
	if itype == 0:
	        self.showCmdInputBox()
	else:
		url = self.urltype[itype]
		self.session.open(Getvids, url)
		
    def showCmdInputBox(self):
               	self.session.openWithCallback(self.search, InputBox, title=_("Please enter seach words"), text= " ", maxSize=False, visible_width = 56, type=Input.TEXT)

    def search(self, sline):
                sline = sline.replace(" ", "+")                
                surl = "http://www.metacafe.com/tags/" + sline
#                print "surl = ", surl 
                self.session.open(Getvids, surl)
		
		

class Getvids(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Videos" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, url):
		self.skin = Getvids.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                self.urls = []
                self.names = []
                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
           self["info"].setText("Downloading list...")
           furl = self.url
           print "furl =", furl
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           iurllast = " "
           iname = []
           surl = []
           self.names = []
           self.urls = []

	   i = 0
	   j = 0
	   icount = 0
	   start = 0
	   while i<20 :
                n2 = fpage.find('href="/watch/', start)
                if n2<0:
                       break 
                n3 = fpage.find('"',(n2+10))
                if n3<0:
                       break
                n4 = fpage.find('"', (n3+10))       
                iurl = "http://www.metacafe.com/watch/" + fpage[(n2+13):(n3-1)]
                if iurl != iurllast:
                         self.urls.append(j)
                         self.urls[j] = iurl
                         print "self.urls[j] =", self.urls[j]
                         print "iurllast =", iurllast
                         iurllast = self.urls[j]
                         self.names.append(j)
                         self.names[j] = fpage[(n3+9):(n4)]
                         j = j+1
#               
                start = n4 + 5
                i = i+1
                
           self["info"].setText("")
           self["list"].setList(self.names)
   
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
		itype = self["list"].getSelectionIndex()
		url = self.urls[itype]
		self.session.open(Playvid, url)

 
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		

class Playvid(Screen):

    def __init__(self, session, url):
#		self.skin = Playvid.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.session.nav.stopService()
                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
           self["info"].setText(" ")
           furl = self.url
           print "furl =", furl
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
          n0 = fpage.find("fplayer/yt", 0)
          if n0>-1 :
                n5 = fpage.find("/", (n0+11))
                ytid = fpage[(n0 + 11):n5]
#                url = "http://www.youtube.com/watch?v=" + ytid 
                self.session.open(Playvidyt, ytid)
          
          else:
                iurl = []
                n1 = fpage.find("flashVars", 0)
                if n1<0:
                       return
                n2 = fpage.find("com%255D%25", (n1+5))
                if n2<0:
                       return                
                n3 = fpage.find("%22%2C", (n2+5))
                if n3<0:
                       return
                n4 = fpage.find("%22%7D", (n3+5))
                if n4<0:
                       return
                item1 = fpage[(n2 + 12):n3]
                item2 = fpage[(n3 + 21):n4]
                       
                iurl = "http://v.mccont.com/ItemFiles/%5BFrom%20www.metacafe.com%5D%2" + item1 + "?__gda__=" + item2
                self.url = iurl
                self.name = " "
                self.play()

              	
    def play(self):
                sref = eServiceReference(4097,0,self.url)
	        self.session.nav.playService(sref)

    def close(self):
                self.session.nav.stopService()
                self.session.nav.playService(self.srefOld)
                Screen.close(self, False)
 
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    
    def okClicked(self):
		return
    
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		

class Playvidyt(Screen):

    def __init__(self, session, ytid):
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                
                self.ytid = ytid
                
                self.url = "http://www.youtube.com/watch?v=" + ytid
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.session.nav.stopService()
                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
           self["info"].setText(" ")
           furl = self.url
           print "furl =", furl
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
                n1 = fpage.find("fmt_url_map")
                n2 = fpage.find("http",(n1+5))
                n3 = fpage.find("%2C",(n1+5))
                iurl = fpage[(n2):(n3)]
                iurl = iurl.replace("%3A",":")
                iurl = iurl.replace("%2F","/") 
                iurl = iurl.replace("%3F","?")
                iurl = iurl.replace("%3D","=") 
                iurl = iurl.replace("%252C",",")
                iurl = iurl.replace("%26","&")  
                print "iurl =", iurl
                
                self.url = iurl
                self.name = " "
                self.play()
               	
    def play(self):
                sref = eServiceReference(4097,0,self.url)
                print " self.url =", self.url
	        self.session.nav.playService(sref)

    def close(self):
                self.session.nav.stopService()
                self.session.nav.playService(self.srefOld)
                Screen.close(self, False) 
 
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
    def okClicked(self):
		return

    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		

def main(session, **kwargs):
        session.open(Vidtype)
        
		

def Plugins(**kwargs):
	return PluginDescriptor(name="MetacafeDirect", description="Watch videos from Metacafe", where = PluginDescriptor.WHERE_PLUGINMENU, fnc=main)




